398317d3a8a256ec68fcd317635d0d7a4628f1c5
[osm/RO.git] / scripts / install-openmano.sh
1 #!/bin/bash
2
3 ##
4 # Copyright 2015 Telefonica Investigacion y Desarrollo, S.A.U.
5 # This file is part of openmano
6 # All Rights Reserved.
7 #
8 # Licensed under the Apache License, Version 2.0 (the "License"); you may
9 # not use this file except in compliance with the License. You may obtain
10 # a copy of the License at
11 #
12 # http://www.apache.org/licenses/LICENSE-2.0
13 #
14 # Unless required by applicable law or agreed to in writing, software
15 # distributed under the License is distributed on an "AS IS" BASIS, WITHOUT
16 # WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. See the
17 # License for the specific language governing permissions and limitations
18 # under the License.
19 #
20 # For those usages not covered by the Apache License, Version 2.0 please
21 # contact with: nfvlabs@tid.es
22 ##
23
24 #ONLY TESTED in Ubuntu 16.04 partially tested in Ubuntu 14.10 14.04 16.04, CentOS7 and RHEL7
25 #Get needed packages, source code and configure to run openmano
26 #Ask for database user and password if not provided
27
28 function usage(){
29 echo -e "usage: sudo -E $0 [OPTIONS]"
30 echo -e "Install last stable source code in ./openmano and the needed packages"
31 echo -e "On a Ubuntu 16.04 it configures openmano as a service"
32 echo -e " OPTIONS"
33 echo -e " -u USER: database admin user. 'root' by default. Prompts if needed"
34 echo -e " -p PASS: database admin password to be used or installed. Prompts if needed"
35 echo -e " -q --quiet: install in unattended mode"
36 echo -e " -h --help: show this help"
37 echo -e " -b REFSPEC: install from source code using a specific branch (master, v2.0, ...) or tag"
38 echo -e " -b master (main RO branch)"
39 echo -e " -b v2.0 (v2.0 branch)"
40 echo -e " -b tags/v1.1.0 (a specific tag)"
41 echo -e " ..."
42 echo -e " --develop: install last version for developers, and do not configure as a service"
43 echo -e " --forcedb: reinstall mano_db DB, deleting previous database if exists and creating a new one"
44 echo -e " --updatedb: do not reinstall mano_db DB if it exists, just update database"
45 echo -e " --force: makes idenpotent, delete previous installations folders if needed. It assumes --updatedb if --forcedb option is not provided"
46 echo -e " --noclone: assumes that openmano was cloned previously and that this script is run from the local repo"
47 echo -e " --no-install-packages: use this option to skip updating and installing the requires packages. This avoid wasting time if you are sure requires packages are present e.g. because of a previous installation"
48 echo -e " --no-db: do not install mysql server"
49 }
50
51 function install_packages(){
52 [ -x /usr/bin/apt-get ] && apt-get install -y $*
53 [ -x /usr/bin/yum ] && yum install -y $*
54
55 #check properly installed
56 for PACKAGE in $*
57 do
58 PACKAGE_INSTALLED="no"
59 [ -x /usr/bin/apt-get ] && dpkg -l $PACKAGE &>> /dev/null && PACKAGE_INSTALLED="yes"
60 [ -x /usr/bin/yum ] && yum list installed $PACKAGE &>> /dev/null && PACKAGE_INSTALLED="yes"
61 if [ "$PACKAGE_INSTALLED" = "no" ]
62 then
63 echo "failed to install package '$PACKAGE'. Revise network connectivity and try again" >&2
64 exit 1
65 fi
66 done
67 }
68
69 function ask_user(){
70 # ask to the user and parse a response among 'y', 'yes', 'n' or 'no'. Case insensitive
71 # Params: $1 text to ask; $2 Action by default, can be 'y' for yes, 'n' for no, other or empty for not allowed
72 # Return: true(0) if user type 'yes'; false (1) if user type 'no'
73 read -e -p "$1" USER_CONFIRMATION
74 while true ; do
75 [ -z "$USER_CONFIRMATION" ] && [ "$2" == 'y' ] && return 0
76 [ -z "$USER_CONFIRMATION" ] && [ "$2" == 'n' ] && return 1
77 [ "${USER_CONFIRMATION,,}" == "yes" ] || [ "${USER_CONFIRMATION,,}" == "y" ] && return 0
78 [ "${USER_CONFIRMATION,,}" == "no" ] || [ "${USER_CONFIRMATION,,}" == "n" ] && return 1
79 read -e -p "Please type 'yes' or 'no': " USER_CONFIRMATION
80 done
81 }
82
83 GIT_URL=https://osm.etsi.org/gerrit/osm/RO.git
84 export GIT_OVIM_URL=https://osm.etsi.org/gerrit/osm/openvim.git
85 export GIT_OSMIM_URL=https://osm.etsi.org/gerrit/osm/IM.git
86 DBUSER="root"
87 DBPASSWD=""
88 DBPASSWD_PARAM=""
89 QUIET_MODE=""
90 DEVELOP=""
91 DB_FORCE_UPDATE=""
92 UPDATEDB=""
93 FORCE=""
94 NOCLONE=""
95 NO_PACKAGES=""
96 NO_DB=""
97 COMMIT_ID=""
98
99 while getopts ":u:p:b:hiq-:" o; do
100 case "${o}" in
101 u)
102 export DBUSER="$OPTARG"
103 ;;
104 p)
105 export DBPASSWD="$OPTARG"
106 export DBPASSWD_PARAM="-p$OPTARG"
107 ;;
108 b)
109 export COMMIT_ID=${OPTARG}
110 ;;
111 q)
112 export QUIET_MODE=yes
113 export DEBIAN_FRONTEND=noninteractive
114 ;;
115 h)
116 usage && exit 0
117 ;;
118 -)
119 [ "${OPTARG}" == "help" ] && usage && exit 0
120 [ "${OPTARG}" == "develop" ] && export DEVELOP="y" && continue
121 [ "${OPTARG}" == "forcedb" ] && DB_FORCE_UPDATE="${DB_FORCE_UPDATE}--forcedb" && continue
122 [ "${OPTARG}" == "updatedb" ] && DB_FORCE_UPDATE="${DB_FORCE_UPDATE}--updatedb" && continue
123 [ "${OPTARG}" == "force" ] && FORCE="y" && continue
124 [ "${OPTARG}" == "noclone" ] && NOCLONE="y" && continue
125 [ "${OPTARG}" == "quiet" ] && export QUIET_MODE=yes && export DEBIAN_FRONTEND=noninteractive && continue
126 [ "${OPTARG}" == "no-install-packages" ] && export NO_PACKAGES=yes && continue
127 [ "${OPTARG}" == "no-db" ] && NO_DB="y" && continue
128 echo -e "Invalid option: '--$OPTARG'\nTry $0 --help for more information" >&2
129 exit 1
130 ;;
131 \?)
132 echo -e "Invalid option: '-$OPTARG'\nTry $0 --help for more information" >&2
133 exit 1
134 ;;
135 :)
136 echo -e "Option '-$OPTARG' requires an argument\nTry $0 --help for more information" >&2
137 exit 1
138 ;;
139 *)
140 usage >&2
141 exit 1
142 ;;
143 esac
144 done
145
146 if [ "$DB_FORCE_UPDATE" == "--forcedb--updatedb" ] || [ "$DB_FORCE_UPDATE" == "--updatedb--forcedb" ] ; then
147 echo "Error: options --forcedb and --updatedb are mutually exclusive" >&2
148 exit 1
149 elif [ -n "$FORCE" ] && [ -z "$DB_FORCE_UPDATE" ] ; then
150 DB_FORCE_UPDATE="--updatedb"
151 fi
152
153 #check root privileges and non a root user behind
154 [ "$USER" != "root" ] && echo "Needed root privileges" >&2 && exit 1
155 if [[ -z "$SUDO_USER" ]] || [[ "$SUDO_USER" = "root" ]]
156 then
157 [[ -z $QUIET_MODE ]] && ! ask_user "Install in the root user (y/N)? " n && echo "Cancelled" && exit 1
158 export SUDO_USER=root
159 fi
160
161 # Discover Linux distribution
162 # try redhat type
163 [ -f /etc/redhat-release ] && _DISTRO=$(cat /etc/redhat-release 2>/dev/null | cut -d" " -f1)
164 # if not assuming ubuntu type
165 [ -f /etc/redhat-release ] || _DISTRO=$(lsb_release -is 2>/dev/null)
166 if [ "$_DISTRO" == "Ubuntu" ]
167 then
168 _RELEASE=$(lsb_release -rs)
169 if [[ ${_RELEASE%%.*} != 14 ]] && [[ ${_RELEASE%%.*} != 16 ]]
170 then
171 [[ -z $QUIET_MODE ]] &&
172 ! ask_user "WARNING! Not tested Ubuntu version. Continue assuming a trusty (14.XX)' (y/N)? " n &&
173 echo "Cancelled" && exit 1
174 _RELEASE = 14
175 fi
176 elif [ "$_DISTRO" == "CentOS" ]
177 then
178 _RELEASE="7"
179 if ! cat /etc/redhat-release | grep -q "7."
180 then
181 [[ -z $QUIET_MODE ]] &&
182 ! ask_user "WARNING! Not tested CentOS version. Continue assuming a '$_RELEASE' type (y/N)? " n &&
183 echo "Cancelled" && exit 1
184 fi
185 elif [ "$_DISTRO" == "Red" ]
186 then
187 _RELEASE="7"
188 if ! cat /etc/redhat-release | grep -q "7."
189 then
190 [[ -z $QUIET_MODE ]] &&
191 ! ask_user "WARNING! Not tested Red Hat OS version. Continue assuming a '$_RELEASE' type (y/N)? " n &&
192 echo "Cancelled" && exit 1
193 fi
194 else #[ "$_DISTRO" != "Ubuntu" -a "$_DISTRO" != "CentOS" -a "$_DISTRO" != "Red" ]
195 _DISTRO_DISCOVER=$_DISTRO
196 [ -x /usr/bin/apt-get ] && _DISTRO="Ubuntu" && _RELEASE="14"
197 [ -x /usr/bin/yum ] && _DISTRO="CentOS" && _RELEASE="7"
198 [[ -z $QUIET_MODE ]] &&
199 ! ask_user "WARNING! Not tested Linux distribution '$_DISTRO_DISCOVER '. Continue assuming a '$_DISTRO $_RELEASE' type (y/N)? " n &&
200 echo "Cancelled" && exit 1
201 fi
202
203 export _DISTRO="$_DISTRO"
204 #check if installed as a service
205 INSTALL_AS_A_SERVICE=""
206 [[ "$_DISTRO" == "Ubuntu" ]] && [[ ${_RELEASE%%.*} == 16 ]] && [[ -z $DEVELOP ]] && INSTALL_AS_A_SERVICE="y"
207
208 # Next operations require knowing BASEFOLDER
209 if [[ -z "$NOCLONE" ]]; then
210 if [[ -n "$INSTALL_AS_A_SERVICE" ]] ; then
211 export BASEFOLDER=__openmano__${RANDOM}
212 else
213 export BASEFOLDER="${PWD}/openmano"
214 fi
215 [[ -n "$FORCE" ]] && rm -rf $BASEFOLDER #make idempotent
216 else
217 HERE=$(dirname $(readlink -f ${BASH_SOURCE[0]}))
218 export BASEFOLDER=$(dirname $HERE)
219 fi
220
221 if [[ -z "$NO_PACKAGES" ]]
222 then
223 echo -e "\n"\
224 "#################################################################\n"\
225 "##### UPDATE REPOSITORIES #####\n"\
226 "#################################################################"
227 [ "$_DISTRO" == "Ubuntu" ] && apt-get update -y &&
228 add-apt-repository -y cloud-archive:queens && apt-get update -y
229
230 [ "$_DISTRO" == "CentOS" -o "$_DISTRO" == "Red" ] && yum check-update -y
231 [ "$_DISTRO" == "CentOS" ] && yum install -y epel-release
232 [ "$_DISTRO" == "Red" ] && wget http://dl.fedoraproject.org/pub/epel/7/x86_64/e/epel-release-7-5.noarch.rpm \
233 && rpm -ivh epel-release-7-5.noarch.rpm && yum install -y epel-release && rm -f epel-release-7-5.noarch.rpm
234 [ "$_DISTRO" == "CentOS" -o "$_DISTRO" == "Red" ] && yum repolist
235
236 echo -e "\n"\
237 "#################################################################\n"\
238 "##### INSTALL REQUIRED PACKAGES #####\n"\
239 "#################################################################"
240 [ "$_DISTRO" == "Ubuntu" ] && install_packages "git make screen wget mysql-client"
241 [ "$_DISTRO" == "CentOS" -o "$_DISTRO" == "Red" ] && install_packages "git make screen wget mariadb-client"
242
243 echo -e "\n"\
244 "#################################################################\n"\
245 "##### INSTALL PYTHON PACKAGES #####\n"\
246 "#################################################################"
247 [ "$_DISTRO" == "Ubuntu" ] && install_packages "python-yaml python-bottle python-mysqldb python-jsonschema "\
248 "python-paramiko python-argcomplete python-requests python-logutils libxml2-dev libxslt-dev python-dev "\
249 "python-pip python-crypto python-networkx"
250 [ "$_DISTRO" == "CentOS" -o "$_DISTRO" == "Red" ] && install_packages "PyYAML MySQL-python python-jsonschema "\
251 "python-paramiko python-argcomplete python-requests python-logutils libxslt-devel libxml2-devel python-devel "\
252 "python-pip python-crypto python-networkx"
253 # The only way to install python-bottle on Centos7 is with easy_install or pip
254 [ "$_DISTRO" == "CentOS" -o "$_DISTRO" == "Red" ] && easy_install -U bottle
255
256 # required for vmware connector TODO move that to separete opt in install script
257 pip2 install pip==9.0.3 || exit 1 # --upgrade pip install pip 10 that does not work
258 pip2 install pyvcloud==19.1.1 || exit 1
259 pip2 install progressbar || exit 1
260 pip2 install prettytable || exit 1
261 pip2 install pyvmomi || exit 1
262 [ "$_DISTRO" == "Ubuntu" ] && install_packages "genisoimage"
263 [ "$_DISTRO" == "CentOS" -o "$_DISTRO" == "Red" ] && install_packages "genisoimage"
264
265 # required for fog connector
266 pip2 install fog05rest || exit 1
267
268 # required for OpenNebula connector
269 pip2 install untangle || exit 1
270 pip2 install -e git+https://github.com/python-oca/python-oca#egg=oca || exit 1
271
272 # required for AWS connector
273 [ "$_DISTRO" == "Ubuntu" ] && install_packages "python-boto"
274 [ "$_DISTRO" == "CentOS" -o "$_DISTRO" == "Red" ] && install_packages "python-boto" #TODO check if at Centos it exists with this name, or PIP should be used
275
276 # install openstack client needed for using openstack as a VIM
277 [ "$_DISTRO" == "Ubuntu" ] && install_packages "python-novaclient python-keystoneclient python-glanceclient "\
278 "python-neutronclient python-cinderclient python-openstackclient "\
279 "python-networking-l2gw"
280 [ "$_DISTRO" == "CentOS" -o "$_DISTRO" == "Red" ] && install_packages "python-devel" && easy_install \
281 python-novaclient python-keystoneclient python-glanceclient python-neutronclient python-cinderclient \
282 python-openstackclient python-networking-l2gw #TODO revise if gcc python-pip is needed
283
284 # required for Azure
285 pip2 install azure
286
287 fi # [[ -z "$NO_PACKAGES" ]]
288
289 if [[ -z $NOCLONE ]]; then
290 echo -e "\n"\
291 "#################################################################\n"\
292 "##### DOWNLOAD SOURCE #####\n"\
293 "#################################################################"
294 if [[ -d "${BASEFOLDER}" ]] ; then
295 if [[ -n "$FORCE" ]] ; then
296 echo "deleting '${BASEFOLDER}' folder"
297 rm -rf "$BASEFOLDER" #make idempotent
298 elif [[ -z "$QUIET_MODE" ]] ; then
299 ! ask_user "folder '${BASEFOLDER}' exists, overwrite (y/N)? " n && echo "Cancelled!" && exit 1
300 rm -rf "$BASEFOLDER"
301 else
302 echo "'${BASEFOLDER}' folder exists. Use "--force" to overwrite" >&2 && exit 1
303 fi
304 fi
305 su $SUDO_USER -c "git clone ${GIT_URL} ${BASEFOLDER}" || ! echo "Error cannot clone from '$GIT_URL'" >&2 || exit 1
306 if [[ -n $COMMIT_ID ]] ; then
307 echo -e "Installing osm-RO from refspec: $COMMIT_ID"
308 su $SUDO_USER -c "git -C ${BASEFOLDER} checkout $COMMIT_ID" ||
309 ! echo "Error cannot checkout '$COMMIT_ID' from '$GIT_URL'" >&2 || exit 1
310 elif [[ -z $DEVELOP ]]; then
311 LATEST_STABLE_TAG=`git -C "${BASEFOLDER}" tag -l "v[0-9]*" | sort -V | tail -n1`
312 echo -e "Installing osm-RO from refspec: tags/${LATEST_STABLE_TAG}"
313 su $SUDO_USER -c "git -C ${BASEFOLDER} checkout tags/${LATEST_STABLE_TAG}" ||
314 ! echo "Error cannot checkout 'tags/${LATEST_STABLE_TAG}' from '$GIT_URL'" >&2 || exit 1
315 else
316 echo -e "Installing osm-RO from refspec: master"
317 fi
318 su $SUDO_USER -c "cp ${BASEFOLDER}/.gitignore-common ${BASEFOLDER}/.gitignore"
319 fi
320
321 echo -e "\n"\
322 "#################################################################\n"\
323 "##### INSTALLING OSM-IM LIBRARY #####\n"\
324 "#################################################################"
325 ${BASEFOLDER}/scripts/install-osm-im.sh
326 OSM_IM_PATH=`python -c 'import osm_im; print osm_im.__path__[0]'` ||
327 ! echo "ERROR installing python-osm-im library!!!" >&2 || exit 1
328
329 echo -e "\n"\
330 "#################################################################\n"\
331 "##### INSTALLING OVIM LIBRARY #####\n"\
332 "#################################################################"
333 ${BASEFOLDER}/scripts/install-lib-osm-openvim.sh
334 OSMLIBOVIM_PATH=`python -c 'import lib_osm_openvim; print lib_osm_openvim.__path__[0]'` ||
335 ! echo "ERROR installing python-lib-osm-openvim library!!!" >&2 || exit 1
336
337 if [ "$_DISTRO" == "CentOS" -o "$_DISTRO" == "Red" ]
338 then
339 echo -e "\n"\
340 "#################################################################\n"\
341 "##### CONFIGURE firewalld #####\n"\
342 "#################################################################"
343 if [[ -z $QUIET_MODE ]] || ask_user "Configure firewalld for openmanod port 9090 (Y/n)? " y
344 then
345 #Creates a service file for openmano
346 echo '<?xml version="1.0" encoding="utf-8"?>
347 <service>
348 <short>openmanod</short>
349 <description>openmanod service</description>
350 <port protocol="tcp" port="9090"/>
351 </service>' > /etc/firewalld/services/openmanod.xml
352 #put proper permissions
353 pushd /etc/firewalld/services > /dev/null
354 restorecon openmanod.xml
355 chmod 640 openmanod.xml
356 popd > /dev/null
357 #Add the openmanod service to the default zone permanently and reload the firewall configuration
358 firewall-cmd --permanent --add-service=openmanod > /dev/null
359 firewall-cmd --reload > /dev/null
360 echo "done."
361 else
362 echo "skipping."
363 fi
364 fi
365
366 echo -e "\n"\
367 "#################################################################\n"\
368 "##### CONFIGURE OPENMANO CLIENT #####\n"\
369 "#################################################################"
370 #creates a link at ~/bin if not configured as a service
371 if [[ -z "$INSTALL_AS_A_SERVICE" ]]
372 then
373 su $SUDO_USER -c 'mkdir -p ${HOME}/bin'
374 su $SUDO_USER -c 'rm -f ${HOME}/bin/openmano'
375 su $SUDO_USER -c 'rm -f ${HOME}/bin/openmano-report'
376 su $SUDO_USER -c 'rm -f ${HOME}/bin/service-openmano'
377 su $SUDO_USER -c "ln -s '${BASEFOLDER}/openmano' "'${HOME}/bin/openmano'
378 su $SUDO_USER -c "ln -s '${BASEFOLDER}/scripts/openmano-report.sh' "'${HOME}/bin/openmano-report'
379 su $SUDO_USER -c "ln -s '${BASEFOLDER}/scripts/service-openmano' "'${HOME}/bin/service-openmano'
380
381 #insert /home/<user>/bin in the PATH
382 #skiped because normally this is done authomatically when ~/bin exists
383 #if ! su $SUDO_USER -c 'echo $PATH' | grep -q "${HOME}/bin"
384 #then
385 # echo " inserting /home/$SUDO_USER/bin in the PATH at .bashrc"
386 # su $SUDO_USER -c 'echo "PATH=\$PATH:\${HOME}/bin" >> ~/.bashrc'
387 #fi
388
389 if [[ $SUDO_USER == root ]]
390 then
391 if ! echo $PATH | grep -q "${HOME}/bin"
392 then
393 echo "PATH=\$PATH:\${HOME}/bin" >> ${HOME}/.bashrc
394 fi
395 fi
396 fi
397
398 #configure arg-autocomplete for this user
399 #in case of minimal instalation this package is not installed by default
400 [[ "$_DISTRO" == "CentOS" || "$_DISTRO" == "Red" ]] && yum install -y bash-completion
401 #su $SUDO_USER -c 'mkdir -p ~/.bash_completion.d'
402 su $SUDO_USER -c 'activate-global-python-argcomplete --user'
403 if ! su $SUDO_USER -c 'grep -q bash_completion.d/python-argcomplete.sh ${HOME}/.bashrc'
404 then
405 echo " inserting .bash_completion.d/python-argcomplete.sh execution at .bashrc"
406 su $SUDO_USER -c 'echo ". ${HOME}/.bash_completion.d/python-argcomplete.sh" >> ~/.bashrc'
407 fi
408
409 if [ -z "$NO_DB" ]; then
410 echo -e "\n"\
411 "#################################################################\n"\
412 "##### INSTALL DATABASE SERVER #####\n"\
413 "#################################################################"
414
415 if [ -n "$QUIET_MODE" ]; then
416 DB_QUIET='-q'
417 fi
418 ${BASEFOLDER}/database_utils/install-db-server.sh -U $DBUSER ${DBPASSWD_PARAM/p/P} $DB_QUIET $DB_FORCE_UPDATE || exit 1
419 echo -e "\n"\
420 "#################################################################\n"\
421 "##### CREATE AND INIT MANO_VIM DATABASE #####\n"\
422 "#################################################################"
423 # Install mano_vim_db after setup
424 ${OSMLIBOVIM_PATH}/database_utils/install-db-server.sh -U $DBUSER ${DBPASSWD_PARAM/p/P} -u mano -p manopw -d mano_vim_db --no-install-packages $DB_QUIET $DB_FORCE_UPDATE || exit 1
425 fi # [ -z "$NO_DB" ]
426
427 if [[ -n "$INSTALL_AS_A_SERVICE" ]]
428 then
429 echo -e "\n"\
430 "#################################################################\n"\
431 "##### CONFIGURE OPENMANO SERVICE #####\n"\
432 "#################################################################"
433
434 ${BASEFOLDER}/scripts/install-openmano-service.sh -f ${BASEFOLDER} `[[ -z "$NOCLONE" ]] && echo "-d"`
435 # rm -rf ${BASEFOLDER}
436 # alias service-openmano="service openmano"
437 # echo 'alias service-openmano="service openmano"' >> ${HOME}/.bashrc
438 echo
439 echo "Done! installed at /opt/openmano"
440 echo " Manage server with 'sudo -E service osm-ro start|stop|status|...' "
441 else
442 echo
443 echo "Done! you may need to logout and login again for loading client configuration"
444 echo " Run './${BASEFOLDER}/scripts/service-openmano start' for starting openmano in a screen"
445 fi